default:
  tags:
    - linaro-jenkins-amd64-debian-buster

variables:
  TRIGGER_PROJECT_ID: 37555984   # https://gitlab.com/leonardo.sandoval1/child-pipeline
  MANIFEST_URL: 'https://github.com/lsandov1/oe-rpb-manifest.git'
  BRANCH: 'master'
  REPO_DIR: $CI_PROJECT_DIR/repo/
  REPO_INFO: $CI_PROJECT_DIR/info
  USER_NAME: 'Leonardo Sandoval'
  USER_EMAIL: 'leonardo.sandoval@linaro.org'
  REPO_TOOL_URL: 'http://commondatastorage.googleapis.com/git-repo-downloads/repo'

stages:
  - polling

cache:
  key: repo-info-$BRANCH
  paths:
    - $REPO_INFO

.poll_branch:
  stage: polling
  script:
    - |
      # first time run, we need to create the info file
      [ ! -e $REPO_INFO ] && touch $REPO_INFO

      # set git credentials
      (git config --global user.name $USER_NAME; git config --global user.email $USER_EMAIL)

      # init and sync, store repo's info log temporally
      ( mkdir -p $REPO_DIR
        cd $REPO_DIR
        repo init -u $MANIFEST_URL -b $BRANCH
        repo sync
        repo info | tee $REPO_INFO.now
      )

      # trigger in case repo differences between last and present run
      if ! diff $REPO_INFO $REPO_INFO.now; then
        mv $REPO_INFO.now $REPO_INFO
        curl -f -X POST -F token="${CI_JOB_TOKEN}" -F ref=master "${CI_API_V4_URL}/projects/${TRIGGER_PROJECT_ID}/trigger/pipeline"
      fi
  cache:
    key: repo-info-$BRANCH
    paths:
      - $REPO_INFO
  artifacts:
    paths:
      - $REPO_INFO

poll master:
  extends: .poll_branch
  variables:
    BRANCH: 'master'
